
#    Note:  This is loaded into the namespace  MEISERDA

#variable started 0


if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable HelpTopic "undefined"

    set Color1(0) Red
    set Color1(1) Green
    set Color2(0) Cyan
    set Color2(1) #D4A017     ;# Orange Gold

    variable Offset0 0
    variable Offset1 0
    variable Offset2 0
    variable Offset3 0
    variable Offset4 0
    variable Offset5 0
    variable Offset6 0
    variable Offset7 0

    variable ON1 0
    variable OFF1 1
    variable ON2 0
    variable OFF2 1
    variable ON3 0
    variable OFF3 1

    variable B0 0
    variable B1 1
    variable B2 0
    variable B3 1

    variable TAC "0"
    variable ADC 0
    variable MASS1 0
    variable MASS2 0
    variable MASS3 0
    variable FIX 0


   proc  show_variables {} {

      for {set i 0} {$i < 6} {incr i} {variable Offset$i; InsertLog "Offset$i = [set Offset$i]"}

       InsertLog "[ReadNETRegister ERDA.TAC.Window1.Base]   [ReadNETRegister ERDA.TAC.Window1.Base]"	


   }

   proc Help {subject} {
       variable HelpTopic

       switch $subject {

          Introduction -
          "Introduction to the System"  {set HelpTopic UsingMEISDataAcq}

          default {}
       }

       do_help
   }

   proc click-erda {vl} {
      set ov [ReadNetRegister ERDA.Enable]
      if {$ov == $vl} {return}    ;#  no mode change
      WriteNETRegister ERDA.Enable $vl
      WriteVMERegister v785n#1.Disable16 $vl              ;# ******************
   }

   proc click-tac {} {
       

   }

   proc set-tacspectrum-tags {args} {}
   proc set-tacwindow-baserange {args} {}
   proc click-save-tac {args} {}
 
   proc do_Drive {w vl} {    ;InsertLog "Drive $w $vl"

       switch $w {
         0 {variable B0; variable B1; set B0 [expr $B0^1]; set B1 [expr $B0^1]; click-erda $B1}
         1 {variable B1; variable B0; set B1 [expr $B1^1]; set B0 [expr $B1^1]; click-erda $B1}
         2 {variable B2; set B2 [expr $B2^1]; click-save-tac $B2}
         3 {variable B3; set B3 [expr $B3^1]; WriteVMERegister v785n#1.Disable16 $B3}           ;# ******************************************
         5 {variable ON1; variable OFF1; set ON1 [expr $ON1^1]; set OFF1 [expr $ON1^1]; WriteNETRegister ERDA.TAC.Window1.Enable $ON1}
         6 {variable OFF1; variable ON1; set OFF1 [expr $OFF1^1]; set ON1 [expr $OFF1^1]; WriteNETRegister ERDA.TAC.Window1.Enable $ON1}
         7 {variable ON2; variable OFF2; set ON2 [expr $ON2^1]; set OFF2 [expr $ON2^1];  WriteNETRegister ERDA.TAC.Window2.Enable $ON2}
         8 {variable OFF2; variable ON2; set OFF2 [expr $OFF2^1]; set ON2 [expr $OFF2^1];  WriteNETRegister ERDA.TAC.Window2.Enable $ON2}
         9 {variable ON3; variable OFF3; set ON3 [expr $ON3^1]; set OFF3 [expr $ON3^1];  WriteNETRegister ERDA.TAC.Window3.Enable $ON3}
         10 {variable OFF3; variable ON3; set OFF3 [expr $OFF3^1]; set ON3 [expr $OFF3^1];  WriteNETRegister ERDA.TAC.Window3.Enable $ON3}
         11 {variable TAC; set TAC [expr $vl & 15]}
         12 {variable MASS1; set MASS1 $vl}
         13 {variable MASS2; set MASS2 $vl}
         14 {variable MASS3; set MASS3 $vl}
         15 {variable FIX; set FIX $vl}
         default {}
       }
   }

   proc do_Win {vl} {    ;InsertLog "Win $vl"

       switch $vl {
         0 -
         1  {set-tacspectrum-tags 1}
         2  {set-tacwindow-baserange 1}
         3  {set-tacspectrum-tags 2}
         4  {set-tacwindow-baserange 3}
         5  {set-tacspectrum-tags 1}
         6  {set-tacwindow-baserange 1}
         7  {set-tacspectrum-tags}
         8  {set-tacwindow-baserange}
         default {}
       }
   }

   proc do_Setting {reg vl} {     ;InsertLog "Setting $reg $vl"
      variable Offset0
      variable Offset1
      variable Offset2
      variable Offset3
      variable Offset4
      variable Offset5
      variable Offset6
      variable Offset7

       switch $reg {
        rangeInput0     {set Offset0 [set vl]; WriteNETRegister ERDA.TAC.Window1.Base [set vl]ns}
        rangeInput1     {set Offset1 [set vl]; WriteNETRegister ERDA.TAC.Window1.Range [set vl]ns}
        rangeInput2     {set Offset2 [set vl]; WriteNETRegister ERDA.TAC.Window2.Base [set vl]ns}
        rangeInput3     {set Offset3 [set vl]; WriteNETRegister ERDA.TAC.Window2.Range [set vl]ns}
        rangeInput4     {set Offset4 [set vl]; WriteNETRegister ERDA.TAC.Window3.Base [set vl]ns}
        rangeInput5     {set Offset5 [set vl]; WriteNETRegister ERDA.TAC.Window3.Range [set vl]ns}
        rangeInput6     {set Offset6 [set vl]; WriteNETRegister ERDA.TAC.Scale $vl}
        rangeInput7     {set Offset7 [set vl]; WriteVMERegister v785n#1.Threshold16 $vl}
        default {}
     }
   }

   proc UpdateModule {} {

   }


   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set n [second [lindex $cgidata 1]]
              set vl [third [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   HELP     {Help $vl}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   RANGE   -
                   TEXT    -
                   SETTING {do_Setting $n $vl}

                   DRIVE   {do_Drive [second [lindex $cgidata 1]]  [third [lindex $cgidata 1]]}
                   WIN     {do_Win [second [lindex $cgidata 1]]}

                   REDISPLAY {UpdateModule}
                   UPDATE    {UpdateModule}

                   EXPERT   {$vl [third [lindex $cgidata 1]]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        UpdateModule
     }
     UpdateModule

}   ;# end of if {$started == 0}



