

#    taken from MEIS/lynxos/include/meis.h

puts "loading MEIS.defn.tcl"

set LOCAL_REGS_NETVAR	"MeisRegs"

#define REAL_ADC_CHANS 16                   /* real number of ADC channe */
#define ADC_CHANS (2*REAL_ADC_CHANS)    /* apparent number of ADC channels */

#define NUM_STEPPERS 5                            /* number of stepper motors */
set STEPPER_SIZE 14     ;#                   /* number of stepper registers */

set LOCAL_GO 1
#define  LOCAL_TEST 1
#define  LOCAL_BADEVENT 2
set  LOCAL_ANGLEWINDOW 3
set  LOCAL_ENERGYWINDOW 4
set  LOCAL_SCAN_SPEC 5
set  LOCAL_SCAN_SPEC_ACTIVE 6
set  LOCAL_SCAN_CHAN 7
set  LOCAL_SCAN_DIO 8
set  LOCAL_STEPPER_BASE 9
#define  LOCAL_STEPPER_CURRENT(s) ((LOCAL_STEPPER_BASE+0)+(s)*STEPPER_SIZE)  // 9,23,37,51,65
#define  LOCAL_STEPPER_REQUEST(s) ((LOCAL_STEPPER_BASE+1)+(s)*STEPPER_SIZE)  // 10..66
#define  LOCAL_STEPPER_RANGE(s) ((LOCAL_STEPPER_BASE+2)+(s)*STEPPER_SIZE) // 11..67
#define  LOCAL_STEPPER_PITCH(s) ((LOCAL_STEPPER_BASE+3)+(s)*STEPPER_SIZE)  // 12..68
#define  LOCAL_STEPPER_DWELL(s) ((LOCAL_STEPPER_BASE+4)+(s)*STEPPER_SIZE)  // 13..69
#define  LOCAL_STEPPER_SCAN(s) ((LOCAL_STEPPER_BASE+5)+(s)*STEPPER_SIZE) // 14..70
#define  LOCAL_STEPPER_ZERO(s) ((LOCAL_STEPPER_BASE+6)+(s)*STEPPER_SIZE) // 15..71
#define  LOCAL_STEPPER_ENABLE(s) ((LOCAL_STEPPER_BASE+7)+(s)*STEPPER_SIZE) // 16..72
#define  LOCAL_STEPPER_DRIVE(s) ((LOCAL_STEPPER_BASE+8)+(s)*STEPPER_SIZE) // 17..73
#define  LOCAL_STEPPER_STATUS(s) ((LOCAL_STEPPER_BASE+9)+(s)*STEPPER_SIZE) // 18..74
#define  LOCAL_STEPPER_SPEED(s) ((LOCAL_STEPPER_BASE+10)+(s)*STEPPER_SIZE) // 19..75
#define  LOCAL_STEPPER_ACCEL(s) ((LOCAL_STEPPER_BASE+11)+(s)*STEPPER_SIZE) // 20..76
#define  LOCAL_STEPPER_RATIO(s) ((LOCAL_STEPPER_BASE+12)+(s)*STEPPER_SIZE) // 21..77
#define  LOCAL_STEPPER_DEADB(s) ((LOCAL_STEPPER_BASE+13)+(s)*STEPPER_SIZE) // 22,36,50,64,78

#define  LOCAL_CORNER_A_CHAN (LOCAL_STEPPER_BASE+(NUM_STEPPERS*STEPPER_SIZE))  // 79
#define  LOCAL_CORNER_B_CHAN (LOCAL_CORNER_A_CHAN+1)	// 80
#define  LOCAL_CORNER_C_CHAN (LOCAL_CORNER_B_CHAN+1)	// 81
#define  LOCAL_CORNER_D_CHAN (LOCAL_CORNER_C_CHAN+1)	// 82


set  LOCAL_ERDA_BASE 83  ;#		    (LOCAL_CORNER_D_CHAN + 1)	// 83
set  LOCAL_ERDA_ENABLE 83  ;#	    (LOCAL_ERDA_BASE + 0)	// 83
set  LOCAL_ERDA_TACCHAN 84  ;#	    (LOCAL_ERDA_BASE + 1)	// 84
set  LOCAL_ERDA_TAC_SCALE 85  ;#	    (LOCAL_ERDA_BASE + 2)	// 85
set  LOCAL_ERDA_TACWINDOW1_BASE 86  ;#  (LOCAL_ERDA_BASE + 3)	// 86
set  LOCAL_ERDA_TACWINDOW1_RANGE 87  ;# (LOCAL_ERDA_BASE + 4)	// 87
set  LOCAL_ERDA_TACWINDOW2_BASE 88  ;#  (LOCAL_ERDA_BASE + 5)	// 88
set  LOCAL_ERDA_TACWINDOW2_RANGE 89  ;# (LOCAL_ERDA_BASE + 6)	// 89
set  LOCAL_ERDA_TACWINDOW3_BASE 90  ;#  (LOCAL_ERDA_BASE + 7)	// 90
set  LOCAL_ERDA_TACWINDOW3_RANGE 91  ;# (LOCAL_ERDA_BASE + 8)	// 91
set  LOCAL_ERDA_WINDOW1_ENABLE 92  ;#   (LOCAL_ERDA_BASE + 9)	// 92
set  LOCAL_ERDA_WINDOW2_ENABLE 93  ;#   (LOCAL_ERDA_BASE + 10)	// 93
set  LOCAL_ERDA_WINDOW3_ENABLE 94  ;#   (LOCAL_ERDA_BASE + 11)	// 94

set  LOCAL_ADC_PEDESTAL_BASE 95   ;#    (LOCAL_ERDA_BASE+12)	// 95
for {set Ch 0} {$Ch <= 30} {incr Ch 2} {
   set  LOCAL_ADC_PEDESTAL([set Ch])	   [expr $LOCAL_ADC_PEDESTAL_BASE+$Ch]
}

#define  LOCAL_DATA_COLLECTION_TIME  (LOCAL_ADC_PEDESTAL(ADC_CHANS))	// 127

#define  LOCAL_REGS_LEN		    (LOCAL_DATA_COLLECTION_TIME+1)	// 128

#define MAX_ADC_VAL 0x1000 /* 12 bit ADCs */

#define MAX_ENERGY 1023                   /* resolution of energy spectrum */
#define MAX_ANGLE  256                    /* resolution of angle spectrum  */

#define DATA_ENERGY 93                             /* data energy spectrum */
#define DATA_ANGLE  183                            /* data angle spectrum  */
#define BASE_ANGLE  41                     /* base of data angle spectrum  */

#define MAX_SCAN 100              /* number of channels in a scan spectrum */


#    taken from MEIS/lynxos/include/meis.h

set ROTA_STEPPER 0    ;#   /* stepper motor driving rotation goniometer */
set SPIN_STEPPER 1    ;#   /* stepper motor driving spin goniometer */
set TILT_STEPPER 2    ;#   /* stepper motor driving tilt goniometer */
set ANAL_STEPPER 3    ;#   /* stepper motor driving analyser table */
set Z_STEPPER    4    ;#   /* stepper driving goniometer Z direction */

#define ROTA_SPEED  440       /* stepper speed for rotation (normal) */
#define SPIN_SPEED  440       /* stepper speed for spin (normal) */
#define TILT_SPEED  440       /* stepper speed for tilt (normal) */
set ANAL_SPEED   40     ;#  /* stepper speed for analyser (slow) */
#define Z_SPEED    1280       /* stepper speed for height (fast) */

#define ROTA_ACCEL  0          /* default stepper acceleration for rotation */
#define SPIN_ACCEL  0          /* default stepper acceleration for spin */
#define TILT_ACCEL  0          /* default stepper acceleration for tilt */
#define ANAL_ACCEL  0          /* default stepper acceleration for analyser */
#define Z_ACCEL  Z_SPEED       /* specific stepper acceleration for height */

#define ROTA_RATIO  4       /* encoder:motor ratio for rotation (4:1) */
#define SPIN_RATIO  4       /* encoder:motor ratio for spin (4:1) */
#define TILT_RATIO  4       /* encoder:motor ratio for tilt (4:1) */
#define ANAL_RATIO  4       /* encoder:motor ratio for analyser (4:1) */
#define Z_RATIO     5       /* encoder:motor ratio for height, new encoder (5:1) */

#define ROTA_DEADBAND  0       /* stop within +/- this value (no deadband) */
#define SPIN_DEADBAND  0       /* stop within +/- this value (no deadband) */
#define TILT_DEADBAND  0       /* stop within +/- this value (no deadband) */
#define ANAL_DEADBAND  0       /* stop within +/- this value (no deadband) */
#define Z_DEADBAND     1       /* stop within +/- this value (-1 <-> +1)   */

#define STEP_BACKLASH 50             /* number of steps to deal with backlash */
#define STEP_OVERSHOOT 12   /* number of encoder steps to deal with overshoot */


set  LOCAL_STEPPER_CURRENT(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+0)+($ANAL_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_REQUEST(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+1)+($ANAL_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_RANGE(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+2)+($ANAL_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_PITCH(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+3)+($ANAL_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DWELL(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+4)+($ANAL_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_SCAN(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+5)+($ANAL_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ZERO(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+6)+($ANAL_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ENABLE(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+7)+($ANAL_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DRIVE(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+8)+($ANAL_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_STATUS(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+9)+($ANAL_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_SPEED(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+10)+($ANAL_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ACCEL(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+11)+($ANAL_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_RATIO(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+12)+($ANAL_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DEADB(ANAL_STEPPER) [expr ($LOCAL_STEPPER_BASE+13)+($ANAL_STEPPER*$STEPPER_SIZE)]

set  LOCAL_STEPPER_CURRENT(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+0)+($ROTA_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_REQUEST(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+1)+($ROTA_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_RANGE(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+2)+($ROTA_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_PITCH(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+3)+($ROTA_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DWELL(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+4)+($ROTA_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_SCAN(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+5)+($ROTA_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ZERO(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+6)+($ROTA_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ENABLE(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+7)+($ROTA_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DRIVE(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+8)+($ROTA_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_STATUS(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+9)+($ROTA_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_SPEED(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+10)+($ROTA_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ACCEL(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+11)+($ROTA_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_RATIO(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+12)+($ROTA_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DEADB(ROTA_STEPPER) [expr ($LOCAL_STEPPER_BASE+13)+($ROTA_STEPPER*$STEPPER_SIZE)]


set  LOCAL_STEPPER_CURRENT(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+0)+($TILT_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_REQUEST(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+1)+($TILT_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_RANGE(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+2)+($TILT_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_PITCH(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+3)+($TILT_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DWELL(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+4)+($TILT_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_SCAN(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+5)+($TILT_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ZERO(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+6)+($TILT_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ENABLE(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+7)+($TILT_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DRIVE(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+8)+($TILT_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_STATUS(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+9)+($TILT_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_SPEED(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+10)+($TILT_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ACCEL(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+11)+($TILT_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_RATIO(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+12)+($TILT_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DEADB(TILT_STEPPER) [expr ($LOCAL_STEPPER_BASE+13)+($TILT_STEPPER*$STEPPER_SIZE)]


set  LOCAL_STEPPER_CURRENT(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+0)+($SPIN_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_REQUEST(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+1)+($SPIN_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_RANGE(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+2)+($SPIN_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_PITCH(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+3)+($SPIN_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DWELL(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+4)+($SPIN_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_SCAN(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+5)+($SPIN_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ZERO(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+6)+($SPIN_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ENABLE(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+7)+($SPIN_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DRIVE(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+8)+($SPIN_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_STATUS(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+9)+($SPIN_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_SPEED(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+10)+($SPIN_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ACCEL(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+11)+($SPIN_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_RATIO(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+12)+($SPIN_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DEADB(SPIN_STEPPER) [expr ($LOCAL_STEPPER_BASE+13)+($SPIN_STEPPER*$STEPPER_SIZE)]


set  LOCAL_STEPPER_CURRENT(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+0)+($Z_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_REQUEST(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+1)+($Z_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_RANGE(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+2)+($Z_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_PITCH(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+3)+($Z_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DWELL(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+4)+($Z_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_SCAN(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+5)+($Z_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ZERO(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+6)+($Z_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ENABLE(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+7)+($Z_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DRIVE(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+8)+($Z_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_STATUS(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+9)+($Z_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_SPEED(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+10)+($Z_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_ACCEL(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+11)+($Z_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_RATIO(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+12)+($Z_STEPPER*$STEPPER_SIZE)]
set  LOCAL_STEPPER_DEADB(Z_STEPPER) [expr ($LOCAL_STEPPER_BASE+13)+($Z_STEPPER*$STEPPER_SIZE)]



     DefineNETRegister MEIS.Go                        netDigital  "-a $LOCAL_GO  -w 32 -p rw -f d -i 0"

     DefineNETRegister Detector.Scan.Spectrum         netDigital  "-a $LOCAL_SCAN_SPEC  -w 32 -p rw -f d -i 0"
     DefineNETRegister Detector.Scan.ActiveSpectrum   netDigital  "-a $LOCAL_SCAN_SPEC_ACTIVE -w 32 -p rw  -f d -i 0"
     DefineNETRegister Detector.Scan.Channel          netDigital  "-a $LOCAL_SCAN_CHAN -w 32 -p rw  -f d -i 0"
     DefineNETRegister Detector.Scan.ControlAddress   netDigital  "-a $LOCAL_SCAN_DIO - w32 -p rw  -f d -i 0"
     DefineNETRegister Detector.Angle.Scan.Window     netAnalogue "-a $LOCAL_ANGLEWINDOW -w 32 -p rw -q * -u% -d 0 -r 0:0%,1000:100% -i 100%"
     DefineNETRegister Detector.Energy.Scan.Window    netAnalogue "-a $LOCAL_ENERGYWINDOW - w32 -p rw -q * -u% -d 0 -r 0:0%,1000:100% -i 100%"

    for {set Ch 0} {$Ch <= 30} {incr Ch 2} {
 	DefineNETRegister Detector.ADC.Pedestal[set Ch]      netDigital  "-a $LOCAL_ADC_PEDESTAL([set Ch]) - w32 - prw  -f d"
    }

     DefineNETRegister Analyser.Angle.Request       netAnalogue "-a $LOCAL_STEPPER_REQUEST(ANAL_STEPPER) -w 32 -p rw -q * -u deg -d 3 -r 0x8029bf:0deg,0x7fb7ac:360deg -i 120deg"
     DefineNETRegister Analyser.Angle               netAnalogue "-a $LOCAL_STEPPER_CURRENT(ANAL_STEPPER) -w 32 -p ro -q * -u deg -d 3 -r 0x8029bf:0deg,0x7fb7ac:360deg"
     DefineNETRegister Analyser.Angle.Scan.Range    netAnalogue "-a $LOCAL_STEPPER_RANGE(ANAL_STEPPER)  -w 32 -p rw -q * -u deg -d 0 -r 0:0deg,811:10deg -i 10deg"
     DefineNETRegister Analyser.Angle.Scan.Pitch    netAnalogue "-a $LOCAL_STEPPER_PITCH(ANAL_STEPPER)  -w 32 -p rw -q * -u deg -d 6 -r 0:0deg,264:3.25deg -i 0.05deg"
     DefineNETRegister Analyser.Angle.Scan.Dwell    netAnalogue "-a $LOCAL_STEPPER_DWELL(ANAL_STEPPER)  -w 32 -p rw -q * -u s   -d 1 -r 0:0s,3600:60s -i 10s"
     DefineNETRegister Analyser.Angle.Scan          netDigital  "-a $LOCAL_STEPPER_SCAN(ANAL_STEPPER)  -w 32 -p rw -f d -i 0"
     DefineNETRegister Analyser.Angle.Zero          netDigital  "-a $LOCAL_STEPPER_ZERO(ANAL_STEPPER)  -w 16 -p rw -f d -i 0"
     DefineNETRegister Analyser.Angle.Enable        netDigital  "-a $LOCAL_STEPPER_ENABLE(ANAL_STEPPER)  -w 16 -p rw -f d -i 0"
     DefineNETRegister Analyser.Angle.Drive         netDigital  "-a $LOCAL_STEPPER_DRIVE(ANAL_STEPPER)  -w 16 -p ro -f d"
     DefineNETRegister Analyser.Angle.Status        netDigital  "-a $LOCAL_STEPPER_STATUS(ANAL_STEPPER)  -w 16 -p ro -f x"
     DefineNETRegister Analyser.Angle.Complete      netDigital  "-a $LOCAL_STEPPER_STATUS(ANAL_STEPPER)  -w 16 -p ro -f d -b 0 -l 1"
     DefineNETRegister Analyser.Angle.Home          netDigital  "-a $LOCAL_STEPPER_STATUS(ANAL_STEPPER)  -w 16 -p ro -f d -b 1 -l 1"
     DefineNETRegister Analyser.Angle.Full          netDigital  "-a $LOCAL_STEPPER_STATUS(ANAL_STEPPER)  -w 16 -p ro -f d -b 2 -l 1"
     DefineNETRegister Analyser.Angle.Fault         netDigital  "-a $LOCAL_STEPPER_STATUS(ANAL_STEPPER)  -w 16 -p ro -f d -b 3 -l 1"
     DefineNETRegister Analyser.Angle.Go            netDigital  "-a $LOCAL_STEPPER_STATUS(ANAL_STEPPER)  -w 16 -p ro -f d -b 4 -l 1"
     DefineNETRegister Analyser.Angle.Zeroed        netDigital  "-a $LOCAL_STEPPER_STATUS(ANAL_STEPPER)  -w 16 -p ro -f d -b 5 -l 1"
     DefineNETRegister Analyser.Angle.Speed         netDigital  "-a $LOCAL_STEPPER_SPEED(ANAL_STEPPER)  -w 16 -p rw -f d -i $ANAL_SPEED"
     DefineNETRegister Analyser.Angle.Accel         netDigital  "-a $LOCAL_STEPPER_ACCEL(ANAL_STEPPER)  -w 16 -p rw -f d"
     DefineNETRegister Analyser.Angle.Ratio         netDigital  "-a $LOCAL_STEPPER_RATIO(ANAL_STEPPER)  -w 16 -p rw -f d"
     DefineNETRegister Analyser.Angle.Deadband      netDigital  "-a $LOCAL_STEPPER_DEADB(ANAL_STEPPER)  -w 16 -p rw -f d"

     DefineNETRegister ERDA.Enable                  netDigital   "-a $LOCAL_ERDA_ENABLE           -w 32 -p rw -f d -i 0"
     DefineNETRegister ERDA.TAC.Channel             netDigital   "-a $LOCAL_ERDA_TACCHAN          -w 32 -p rw -f d -i 0"
     DefineNETRegister ERDA.TAC.Scale               netDigital   "-a $LOCAL_ERDA_TAC_SCALE        -w 32 -p rw -f d -i 0"
     DefineNETRegister ERDA.TAC.Window1.Base        netAnalogue  "-a $LOCAL_ERDA_TACWINDOW1_BASE  -w 32 -p rw -q n -u s -d 3 -r 0x0:500ns,0xfff:0ns"
     DefineNETRegister ERDA.TAC.Window1.Range       netAnalogue  "-a $LOCAL_ERDA_TACWINDOW1_RANGE -w 32 -p rw -q n -u s -d 3 -r 0x0:00ns,0xfff:500ns"
     DefineNETRegister ERDA.TAC.Window2.Base        netAnalogue  "-a $LOCAL_ERDA_TACWINDOW2_BASE  -w 32 -p rw -q n -u s -d 3 -r 0x0:500ns,0xfff:0ns"
     DefineNETRegister ERDA.TAC.Window2.Range       netAnalogue  "-a $LOCAL_ERDA_TACWINDOW2_RANGE -w 32 -p rw -q n -u s -d 3 -r 0x0:00ns,0xfff:500ns"
     DefineNETRegister ERDA.TAC.Window3.Base        netAnalogue  "-a $LOCAL_ERDA_TACWINDOW3_BASE  -w 32 -p rw -q n -u s -d 3 -r 0x0:500ns,0xfff:0ns"
     DefineNETRegister ERDA.TAC.Window3.Range       netAnalogue  "-a $LOCAL_ERDA_TACWINDOW3_RANGE -w 32 -p rw -q n -u s -d 3 -r 0x0:00ns,0xfff:500ns"
     DefineNETRegister ERDA.TAC.Window1.Enable      netDigital   "-a $LOCAL_ERDA_WINDOW1_ENABLE   -w 32 -p rw -f d -i 0"
     DefineNETRegister ERDA.TAC.Window2.Enable      netDigital   "-a $LOCAL_ERDA_WINDOW2_ENABLE   -w 32 -p rw -f d -i 0"
     DefineNETRegister ERDA.TAC.Window3.Enable      netDigital   "-a $LOCAL_ERDA_WINDOW3_ENABLE   -w 32 -p rw -f d -i 0"

#/* Rota - Rotation 1 - 360 deg in encoder steps of (0.0x18 deg)/4 = 0.0045deg/step */
#/* N.B. the "digital zero" point (0x800000) corresponds to 53deg not 0 */
#/* i.e. the goniometer is physically twisted round to a position at an offset of 53deg*/

     DefineNETRegister Goniometer.Rota.Request       netAnalogue   "-a $LOCAL_STEPPER_REQUEST(ROTA_STEPPER)  -w 32 -p rw -q * -u deg -d 3 -r 0x7ef582:360deg,0x8084d0:-100deg -i 180deg"
     DefineNETRegister Goniometer.Rota               netAnalogue   "-a $LOCAL_STEPPER_CURRENT(ROTA_STEPPER)  -w 32 -p ro -q * -u deg -d 3 -r 0x7ef582:360deg,0x8084d0:-100deg"
     DefineNETRegister Goniometer.Rota.Scan.Range    netAnalogue   "-a $LOCAL_STEPPER_RANGE(ROTA_STEPPER)    -w 32 -p rw -q * -u deg -d 0 -r 0:0deg,0x13880:360deg -i 3deg"
     DefineNETRegister Goniometer.Rota.Scan.Pitch    netAnalogue   "-a $LOCAL_STEPPER_PITCH(ROTA_STEPPER)    -w 32 -p rw -q * -u deg -d 6 -r 0:0deg,0x13880:360deg -i 0.2deg"
     DefineNETRegister Goniometer.Rota.Scan.Dwell    netAnalogue   "-a $LOCAL_STEPPER_DWELL(ROTA_STEPPER)    -w 32 -p rw -q * -u s   -d 1 -r 0:0s,3600:60s -i 1s"
     DefineNETRegister Goniometer.Rota.Scan          netDigital    "-a $LOCAL_STEPPER_SCAN(ROTA_STEPPER)     -w 32 -p rw -f d -i 0"
     DefineNETRegister Goniometer.Rota.Zero          netDigital    "-a $LOCAL_STEPPER_ZERO(ROTA_STEPPER)     -w 16 -p rw -f d -i 0"
     DefineNETRegister Goniometer.Rota.Enable        netDigital    "-a $LOCAL_STEPPER_ENABLE(ROTA_STEPPER)   -w 16 -p rw -f d -i 0"
     DefineNETRegister Goniometer.Rota.Drive         netDigital    "-a $LOCAL_STEPPER_DRIVE(ROTA_STEPPER)    -w 16 -p ro -f d"
     DefineNETRegister Goniometer.Rota.Status        netDigital    "-a $LOCAL_STEPPER_STATUS(ROTA_STEPPER)   -w 16 -p ro -f x"
     DefineNETRegister Goniometer.Rota.Complete      netDigital    "-a $LOCAL_STEPPER_STATUS(ROTA_STEPPER)   -w 16 -p ro -f d -b 0 -l 1"
     DefineNETRegister Goniometer.Rota.Home          netDigital    "-a $LOCAL_STEPPER_STATUS(ROTA_STEPPER)   -w 16 -p ro -f d -b 1 -l 1"
     DefineNETRegister Goniometer.Rota.Full          netDigital    "-a $LOCAL_STEPPER_STATUS(ROTA_STEPPER)   -w 16 -p ro -f d -b 2 -l 1"
     DefineNETRegister Goniometer.Rota.Fault         netDigital    "-a $LOCAL_STEPPER_STATUS(ROTA_STEPPER)   -w 16 -p ro -f d -b 3 -l 1"
     DefineNETRegister Goniometer.Rota.Go            netDigital    "-a $LOCAL_STEPPER_STATUS(ROTA_STEPPER)   -w 16 -p ro -f d -b 4 -l 1"
     DefineNETRegister Goniometer.Rota.Zeroed        netDigital    "-a $LOCAL_STEPPER_STATUS(ROTA_STEPPER)   -w 16 -p ro -f d -b 5 -l 1"
     DefineNETRegister Goniometer.Rota.Speed         netDigital    "-a $LOCAL_STEPPER_SPEED(ROTA_STEPPER)    -w 16 -p rw -f d"
     DefineNETRegister Goniometer.Rota.Accel         netDigital    "-a $LOCAL_STEPPER_ACCEL(ROTA_STEPPER)    -w 16 -p rw -f d"
     DefineNETRegister Goniometer.Rota.Ratio         netDigital    "-a $LOCAL_STEPPER_RATIO(ROTA_STEPPER)    -w 16 -p rw -f d"
     DefineNETRegister Goniometer.Rota.Deadband      netDigital    "-a $LOCAL_STEPPER_DEADB(ROTA_STEPPER)    -w 16 -p rw -f d"

#/* Spin - Rotation 2 - 200 deg in encoder steps of (0.0125 deg)/4 */

     DefineNETRegister Goniometer.Spin.Request       netAnalogue   "-a $LOCAL_STEPPER_REQUEST(SPIN_STEPPER)  -w 32 -p rw -q * -u deg -d 3 -r 0x7f9c00:0deg,0x80af00:220deg -i 90deg"
     DefineNETRegister Goniometer.Spin               netAnalogue   "-a $LOCAL_STEPPER_CURRENT(SPIN_STEPPER)  -w 32 -p ro -q * -u deg -d 3 -r 0x7f9c00:0deg,0x80af00:220deg"
     DefineNETRegister Goniometer.Spin.Scan.Range    netAnalogue   "-a $LOCAL_STEPPER_RANGE(SPIN_STEPPER)    -w 32 -p rw -q * -u deg -d 0 -r 0deg,0x11300:220deg -i 3deg"
     DefineNETRegister Goniometer.Spin.Scan.Pitch    netAnalogue   "-a $LOCAL_STEPPER_PITCH(SPIN_STEPPER)    -w 32 -p rw -q * -u deg -d 6 -r 0:0deg,0x11300:220deg -i 0.2deg"
     DefineNETRegister Goniometer.Spin.Scan.Dwell    netAnalogue   "-a $LOCAL_STEPPER_DWELL(SPIN_STEPPER)    -w 32 -p rw -q * -u s   -d 1 -r 0:0s,3600:60s -i 1s"
     DefineNETRegister Goniometer.Spin.Scan          netDigital    "-a $LOCAL_STEPPER_SCAN(SPIN_STEPPER)     -w 32 -p rw -f d -i 0"
     DefineNETRegister Goniometer.Spin.Zero          netDigital    "-a $LOCAL_STEPPER_ZERO(SPIN_STEPPER)     -w 16 -p rw -f d -i 0"
     DefineNETRegister Goniometer.Spin.Enable        netDigital    "-a $LOCAL_STEPPER_ENABLE(SPIN_STEPPER)   -w 16 -p rw -f d -i 0"
     DefineNETRegister Goniometer.Spin.Drive         netDigital    "-a $LOCAL_STEPPER_DRIVE(SPIN_STEPPER)    -w 16 -p ro -f d"
     DefineNETRegister Goniometer.Spin.Status        netDigital    "-a $LOCAL_STEPPER_STATUS(SPIN_STEPPER)   -w 16 -p ro -f x"
     DefineNETRegister Goniometer.Spin.Complete      netDigital    "-a $LOCAL_STEPPER_STATUS(SPIN_STEPPER)   -w 16 -p ro -f d -b 0 -l 1"
     DefineNETRegister Goniometer.Spin.Home          netDigital    "-a $LOCAL_STEPPER_STATUS(SPIN_STEPPER)   -w 16 -p ro -f d -b 1 -l 1"
     DefineNETRegister Goniometer.Spin.Full          netDigital    "-a $LOCAL_STEPPER_STATUS(SPIN_STEPPER)   -w 16 -p ro -f d -b 2 -l 1"
     DefineNETRegister Goniometer.Spin.Fault         netDigital    "-a $LOCAL_STEPPER_STATUS(SPIN_STEPPER)   -w 16 -p ro -f d -b 3 -l 1"
     DefineNETRegister Goniometer.Spin.Go            netDigital    "-a $LOCAL_STEPPER_STATUS(SPIN_STEPPER)   -w 16 -p ro -f d -b 4 -l 1"
     DefineNETRegister Goniometer.Spin.Zeroed        netDigital    "-a $LOCAL_STEPPER_STATUS(SPIN_STEPPER)   -w 16 -p ro -f d -b 5 -l 1"
     DefineNETRegister Goniometer.Spin.Speed         netDigital    "-a $LOCAL_STEPPER_SPEED(SPIN_STEPPER)    -w 16 -p rw -f d"
     DefineNETRegister Goniometer.Spin.Accel         netDigital    "-a $LOCAL_STEPPER_ACCEL(SPIN_STEPPER)    -w 16 -p rw -f d"
     DefineNETRegister Goniometer.Spin.Ratio         netDigital    "-a $LOCAL_STEPPER_RATIO(SPIN_STEPPER)    -w 16 -p rw -f d"
     DefineNETRegister Goniometer.Spin.Deadband      netDigital    "-a $LOCAL_STEPPER_DEADB(SPIN_STEPPER)    -w 16 -p rw -f d"

#/* tilt +- 3.25 deg in encoder steps of (0.0071 deg)/4 */

     DefineNETRegister Goniometer.Tilt.Request       netAnalogue   "-a $LOCAL_STEPPER_REQUEST(TILT_STEPPER)  -w 32 -p rw -q * -u deg -d 3 -r 0x7ff472:-5.25deg,0x800b8e:5.25deg -i 0deg"
     DefineNETRegister Goniometer.Tilt               netAnalogue   "-a $LOCAL_STEPPER_CURRENT(TILT_STEPPER)  -w 32 -p ro -q * -u deg -d 3 -r 0x7ff472:-5.25deg,0x800b8e:5.25deg"
     DefineNETRegister Goniometer.Tilt.Scan.Range    netAnalogue   "-a $LOCAL_STEPPER_RANGE(TILT_STEPPER)    -w 32 -p rw -q * -u deg -d 0 -r 0:0deg,0xb8e:5.25deg -i 3deg"
     DefineNETRegister Goniometer.Tilt.Scan.Pitch    netAnalogue   "-a $LOCAL_STEPPER_PITCH(TILT_STEPPER)    -w 32 -p rw -q * -u deg -d 6 -r 0:0deg,0xb8e:5.25deg  -i 0.099deg"
     DefineNETRegister Goniometer.Tilt.Scan.Dwell    netAnalogue   "-a $LOCAL_STEPPER_DWELL(TILT_STEPPER)    -w 32 -p rw -q * -u s   -d 1 -r 0:0s,3600:60s -i 1s"
     DefineNETRegister Goniometer.Tilt.Scan          netDigital    "-a $LOCAL_STEPPER_SCAN(TILT_STEPPER)     -w 32 -p rw -f d -i 0"
     DefineNETRegister Goniometer.Tilt.Zero          netDigital    "-a $LOCAL_STEPPER_ZERO(TILT_STEPPER)     -w 16 -p rw -f d -i 0"
     DefineNETRegister Goniometer.Tilt.Enable        netDigital    "-a $LOCAL_STEPPER_ENABLE(TILT_STEPPER)   -w 16 -p rw -f d -i 0"
     DefineNETRegister Goniometer.Tilt.Drive         netDigital    "-a $LOCAL_STEPPER_DRIVE(TILT_STEPPER)    -w 16 -p ro -f d"
     DefineNETRegister Goniometer.Tilt.Status        netDigital    "-a $LOCAL_STEPPER_STATUS(TILT_STEPPER)   -w 16 -p ro -f x"
     DefineNETRegister Goniometer.Tilt.Complete      netDigital    "-a $LOCAL_STEPPER_STATUS(TILT_STEPPER)   -w 16 -p ro -f d -b 0 -l 1"
     DefineNETRegister Goniometer.Tilt.Home          netDigital    "-a $LOCAL_STEPPER_STATUS(TILT_STEPPER)   -w 16 -p ro -f d -b 1 -l 1"
     DefineNETRegister Goniometer.Tilt.Full          netDigital    "-a $LOCAL_STEPPER_STATUS(TILT_STEPPER)   -w 16 -p ro -f d -b 2 -l 1"
     DefineNETRegister Goniometer.Tilt.Fault         netDigital    "-a $LOCAL_STEPPER_STATUS(TILT_STEPPER)   -w 16 -p ro -f d -b 3 -l 1"
     DefineNETRegister Goniometer.Tilt.Go            netDigital    "-a $LOCAL_STEPPER_STATUS(TILT_STEPPER)   -w 16 -p ro -f d -b 4 -l 1"
     DefineNETRegister Goniometer.Tilt.Zeroed        netDigital    "-a $LOCAL_STEPPER_STATUS(TILT_STEPPER)   -w 16 -p ro -f d -b 5 -l 1"
     DefineNETRegister Goniometer.Tilt.Speed         netDigital    "-a $LOCAL_STEPPER_SPEED(TILT_STEPPER)    -w 16 -p rw -f d"
     DefineNETRegister Goniometer.Tilt.Accel         netDigital    "-a $LOCAL_STEPPER_ACCEL(TILT_STEPPER)    -w 16 -p rw -f d"
     DefineNETRegister Goniometer.Tilt.Ratio         netDigital    "-a $LOCAL_STEPPER_RATIO(TILT_STEPPER)    -w 16 -p rw -f d"
     DefineNETRegister Goniometer.Tilt.Deadband      netDigital    "-a $LOCAL_STEPPER_DEADB(TILT_STEPPER)    -w 16 -p rw -f d"

     DefineNETRegister Goniometer.Height             netAnalogue  "-a $LOCAL_STEPPER_CURRENT(Z_STEPPER)   -w 32 -p ro -q * -u mm -d 3 -r 0x7a54c0:-14mm,0x8bf7c0:14mm"
     DefineNETRegister Goniometer.Height.Request     netAnalogue  "-a $LOCAL_STEPPER_REQUEST(Z_STEPPER)   -w 32 -p rw -q * -u mm -d 3 -r 0x7a54c0:-14mm,0x8bf7c0:14mm -i 0mm"
     DefineNETRegister Goniometer.Height.Scan.Range  netAnalogue  "-a $LOCAL_STEPPER_RANGE(Z_STEPPER)     -w 32 -p rw -q * -u mm -d 1 -r 0:0mm,0x64c80:10mm -i 1mm"
     DefineNETRegister Goniometer.Height.Scan.Pitch  netAnalogue  "-a $LOCAL_STEPPER_PITCH(Z_STEPPER)     -w 32 -p rw -q * -u mm -d 6 -r 0:0mm,0x64c80:10mm -i 0.05mm"
     DefineNETRegister Goniometer.Height.Scan.Dwell  netAnalogue  "-a $LOCAL_STEPPER_DWELL(Z_STEPPER)     -w 32 -p rw -q * -u s  -d 0 -r 0:0,1000000:1000 -i 300"

     DefineNETRegister Goniometer.Height.Scan.Dwell.Raw netDigital  "-a $LOCAL_STEPPER_DWELL(Z_STEPPER)     -w 32 -p ro -f d"
     DefineNETRegister Goniometer.Height.Scan        netDigital   "-a $LOCAL_STEPPER_SCAN(Z_STEPPER)      -w 32 -p rw -f d -i 0"
     DefineNETRegister Goniometer.Height.Zero        netDigital   "-a $LOCAL_STEPPER_ZERO(Z_STEPPER)      -w 16 -p rw -f d -i 0"
     DefineNETRegister Goniometer.Height.Enable      netDigital   "-a $LOCAL_STEPPER_ENABLE(Z_STEPPER)    -w 16 -p rw -f d -i 0"
     DefineNETRegister Goniometer.Height.Drive       netDigital   "-a $LOCAL_STEPPER_DRIVE(Z_STEPPER)     -w 16 -p ro -f d"
     DefineNETRegister Goniometer.Height.Status      netDigital   "-a $LOCAL_STEPPER_STATUS(Z_STEPPER)    -w 16 -p ro -f x"
     DefineNETRegister Goniometer.Height.Complete    netDigital   "-a $LOCAL_STEPPER_STATUS(Z_STEPPER)    -w 16 -p ro -f d -b 0 -l 1"
     DefineNETRegister Goniometer.Height.Home        netDigital   "-a $LOCAL_STEPPER_STATUS(Z_STEPPER)    -w 16 -p ro -f d -b 1 -l 1"
     DefineNETRegister Goniometer.Height.Full        netDigital   "-a $LOCAL_STEPPER_STATUS(Z_STEPPER)    -w 16 -p ro -f d -b 2 -l 1"
     DefineNETRegister Goniometer.Height.Fault       netDigital   "-a $LOCAL_STEPPER_STATUS(Z_STEPPER)    -w 16 -p ro -f d -b 3 -l 1"
     DefineNETRegister Goniometer.Height.Go          netDigital   "-a $LOCAL_STEPPER_STATUS(Z_STEPPER)    -w 16 -p ro -f d -b 4 -l 1"
     DefineNETRegister Goniometer.Height.Zeroed      netDigital   "-a $LOCAL_STEPPER_STATUS(Z_STEPPER)    -w 16 -p ro -f d -b 5 -l 1"
     DefineNETRegister Goniometer.Height.Speed       netDigital   "-a $LOCAL_STEPPER_SPEED(Z_STEPPER)     -w 16 -p rw -f d"
     DefineNETRegister Goniometer.Height.Accel       netDigital   "-a $LOCAL_STEPPER_ACCEL(Z_STEPPER)     -w 16 -p rw -f d"
     DefineNETRegister Goniometer.Height.Ratio       netDigital   "-a $LOCAL_STEPPER_RATIO(Z_STEPPER)     -w 16 -p rw -f d"
     DefineNETRegister Goniometer.Height.Deadband    netDigital   "-a $LOCAL_STEPPER_DEADB(Z_STEPPER)     -w 16 -p rw -f d"

puts "Local NET registers"





