
#    Note:  This is loaded into the namespace  MEIS

#variable started 0


if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable HelpTopic "undefined"

    variable NumReg 0


   proc  show_variables {} {


   }

   proc Help {subject} {
       variable HelpTopic

       switch $subject {

          Introduction -
          "Introduction to the System"  {set HelpTopic UsingMEISDataAcq}

          default {}
       }

       do_help
   }
     
      proc do_Initialise {} {
        global env
        global errorCode errorInfo
        variable NumReg
      
        InsertLog "Initialising MEIS Configuration"

#        set rc [DeleteNETRegisters "*"]
#        InsertLog "Delete returns $rc"

        set NumReg 0

        InsertLog "Creating MEIS Configuration"
        set z [catch {source MEIS.defn.tcl} msg]
        if {$z != 0} {Alert "Problem creating MEIS registers\n$msg"; return}
        InsertLog "OK"

        InsertLog "Restoring VME Configuration"
        set rc [catch {Inform VMEConfig doRestore} m]
        InsertLog "VMEConfig Restore returns $rc $m"
        if {$rc != 0} {
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        }
        InsertLog "OK"

        InsertLog "Activating VME Configuration"
        set rc [catch {Inform VMEConfig do_Activate} m]
        InsertLog "VMEConfig Activate returns $rc $m"
        if {$rc != 0} {
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        }
        InsertLog "OK"

        InsertLog "Initialise VME registers"
        set z [catch {InquireVMERegisters *} msg]
        if {$z != 0} {Alert "Problem obtaining VME registers\n$msg"; return}
        set regs [lindex $msg 5]
        foreach reg $regs {WriteVMERegister $reg 0}
        InsertLog "OK"
        
        InsertLog "Initialise NET registers"
        set z [catch {InquireNETRegisters *} msg]
        if {$z != 0} {Alert "Problem obtaining NET registers\n$msg"; return}
        set regs [lindex $msg 5]
        foreach reg $regs {WriteNETRegister $reg 0}
        InsertLog "OK"

        InsertLog "Initialise MEIS registers"
        set z [catch {InquireMEISRegisters *} msg]
        if {$z != 0} {Alert "Problem obtaining MEIS registers\n$msg"; return}
        set regs [lindex $msg 5]
        foreach reg $regs {WriteMEISRegister $reg 0}
        InsertLog "OK"

        InsertLog "Restore VME Settings"
        set rc [catch {Inform VMESaveRestore doRestore} msg] 
        if {$z != 0} {Alert "Problem restoring VME registers\n$msg"; return}
        InsertLog "OK"

        global MIDAS_TapeServer_Exists
        if {[info exists MIDAS_TapeServer_Exists]} {
           namespace eval ::TapeService {   ;#  preload TapeService
              global env

              set started 0
              source [file join $env(MIDASBASE) TclHttpd tcl Common common.tcl]
              set f [file join $env(MIDASBASE) TclHttpd Html TapeService TapeService.tcl]
              set z [catch {source $f} m]
              if {$z != 0} {puts "$f > $m"}
           }

           InsertLog "Start Tape Server"
           set rc [catch {Inform TapeService do_update} m]
           InsertLog "Tape Server returns $rc $m"
           if {$rc != 0} {
        InsertLog "VME Restore returns $rc"
              set rc $errorCode
              return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
           }
           InsertLog "OK"
        }


    }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   HELP     {Help $vl}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   EXPERT   {$vl [third [lindex $cgidata 1]]}
                   Initialise {do_Initialise}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
     }

}   ;# end of if {$started == 0}




