

puts "loading sys.SAC.tcl"

proc Set_SAC_Options {} {puts "Set_SAC_Options"
    variable Options

   load_Options

   if {![info exists Options(UseSAC)]}    {set Options(UseSAC) 0}

   update_Options

}

proc SAC_Configure {} {puts "SAC_Configure"}

proc SAC_DAQ-go {} {puts "SAC_DAQ-go"

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr s9418#$i.VMEStatus} m]  ;#  count S9418 modules 
      if {$z!=0} then {break}
      incr maxmodule
   }

   if {$maxmodule > 0} {
      WriteVMERegisters sac#*.Mode 0   ;#   Silena mode
   } else {
      WriteVMERegisters sac#*.Mode 1   ;#   CAEN mode    ;# if no S9418 modules
   }

      WriteVMERegisters sac#*.MON0 2
#      WriteVMERegisters sac#*.ARM 0
#      WriteVMERegisters sac#*.STR 9   ;#  enable acquisition in sys.tcl
}

proc SAC_DAQ-halt {} {puts "SAC_DAQ-halt"

    WriteVMERegisters sac#*.STR 2
    WriteVMERegisters sac#*.STR 0    ;#   disable acquisition also in sys.tcl
}

proc SAC_DAQ-setup {} {puts "SAC_DAQ-setup"

      WriteVMERegisters sac#*.STR 0
      WriteVMERegisters sac#*.EVCLR 0
      SAC_Configure
}

proc SAC_DAQ-flush {} {puts "SAC_DAQ-flush"}

proc SAC_DAQ-reset {} {puts "SAC_DAQ-reset"

      WriteVMERegisters sac#*.STR 0
      WriteVMERegisters sac#*.EVCLR 0
}

proc define_SAC_config {} {puts "define_SAC_config"
     variable Options

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {ReadVMERegisterAttr sac#$i.VMEStatus} m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   if {$maxmodule > 0} then {set Options(UseSAC) 1} else {set Options(UseSAC) 0}

   if {$maxmodule > 0} then {
      set z [catch {ReadVMERegisterAttr sac#1.VMEStatus} m]
      DefineConfig "0 0 [string range [first $m] 2 end]"   ;# extract base address
   }
}


proc create_SAC_spectra {} {puts "create_SAC_spectra"}


