
#    Note:  This is loaded into the namespace  CAEN_SpecSave

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

#     do_DBUpdate
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

#    variable DBNameList {"xxx"}

   variable index 0
   variable selected 0

   variable FormatOption 0


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable selected
        variable FormatOption 

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "selected=$selected"
        InsertLog "format option = $FormatOption"
#        InsertLog "DBPath = $::CAEN::DBRootName/$::CAEN::DBNodeBase/$::CAEN::DBNodeName"

        foreach module $::VMEConfig::ModuleMenu {InsertLog "$module"}


#        InsertLog "HasBeenConfigured = [ReadRegister HasBeenConfigured]"
#        InsertLog "HasBeenRestored = [ReadRegister HasBeenRestored]"
   }

      proc Selection {} {
          variable selected

          set selected 0;

           set i 1
           foreach item $::VMEConfig::ModuleMenu {
               set selected [expr $selected | (1 << $i)]
               incr i
           }
      }

      proc do_Select {i} {
         variable selected

         set selected [expr $selected | (1 << $i)]
      }

      proc do_UnSelect {i} {
         variable selected

         set selected [expr $selected & ~(1 << $i)]
      }

    proc do_setopt {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        variable AcqSetOption
        global MIDAS_DataAcquisitionControlServer_Exists

        set AcqSetOption $option

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer DoOption "$AcqSetOption"} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoOption "$AcqSetOption"} m]
      }

        if {$rc != 0} {
            InsertLog "DO OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "DO OPTION returned $m ([format "0x%x" $m])"
        }

     }

      proc do_Save {} {
        variable selected
        variable FormatOption

         if {$selected == 0} {Selection}

         InsertLog "Saving module histograms"

         set BAK $::DataAcquisition::ACQSERVER   ;# save

           set i 0
           foreach item $::DataAcquisition::ACQSERVERS {
             incr i
             if {[expr ($selected >> $i) & 1] == 0} {continue}

             set ::DataAcquisition::ACQSERVER $item
             do_setopt "HistogramSave=$FormatOption"

             InsertLog "module histograms saved for $::DataAcquisition::ACQSERVER"
           }

        set ::DataAcquisition::ACQSERVER $BAK    ;# restore

        InsertLog "module histograms saved"

#        Elog INFORMATION "module histograms saved to $::CAEN::DBRootName/$::CAEN::DBNodeBase"

#        do_DBUpdate
    }

      proc do_DBName {vl} {
         global Options

          set ::CAEN::DBNodeBase $vl
          DBCreateNode $::CAEN::DBRootName/$::CAEN::DBNodeBase

          InsertLog "Data Base node $::CAEN::DBRootName/$::CAEN::DBNodeBase contains [DBGetNodes $::CAEN::DBRootName/$::CAEN::DBNodeBase *]"
      }

      proc do_DBUpdate {} {
          variable DBNameList

          set DBNameList {}
          foreach item [DBGetNodes $::CAEN::DBRootName *] {
              if {$item == "Options"} continue
              lappend DBNameList $item
          }
      }
    

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {variable selected; if {$selected == 0} {Selection}}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                OPTIONS  {variable FormatOption; set FormatOption [lindex $w 1]}

                DBNAMES -
                DBNAME   {do_DBName [lindex $w 1]}

                GENKEY   {do_DBName [date +%Y%h%d-%H.%M.%S]}

                SAVE     {do_Save}
      
                SELECT    {do_Select [lindex $w 1]}
                UNSELECT  {do_UnSelect [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }

   Selection

#     do_DBUpdate

#     load_Options
#     set ::CAEN::DBNodeBase $Options(ASIC.settings)
#     set ::CAEN::DBNodeBase Histograms


}  ;# end of if {$started == 0}

