#    Note:  This is loaded into the namespace XVME560

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag
     variable ModuleIndex

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

#     do_Select $ModuleIndex

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0
    
    variable IV 0
    
    variable ID "unknown"
    variable LR 0
    variable LG 0
    variable IE 0
    variable IP 0
    
    set ColorLR(0) White
    set ColorLR(1) Red
    set ColorLG(0) White
    set ColorLG(1) Green
    set Color2(0) White
    set Color2(1) #D4A017     ;# Orange Gold
    
    variable P2 0
    variable P3 0
    variable P4 0
    variable P5 0

#    for {set i 0} {$i <= 7} {incr i} {variable Offset$i 0}

    variable Rmsg
    variable Wmsg

    variable ModuleName xvme560
    variable ModuleMenu {}
    variable ModuleIndex 1

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

    variable P2
    variable P3
    variable P4
    variable P5

             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag "
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"

         InsertLog "P2 = $P2; P3 = $P3; P4 = $P4; P5 = $P5"
         
         InsertLog "Red LED = [ReadRegister Red];  Green LED = [ReadRegister Green]"
         InsertLog "IP = [ReadRegister Int.Pending];  IE = [ReadRegister Int.Enable]"
         
         set ID ""
         for {set i 0} {$i <= 15} {incr i} {variable ID$i; set ID$i [ReadRegister ID$i];  append ID [format %c [set ID$i]] }
         InsertLog "ID = $ID"

 #      for {set i 0} {$i < 8} {incr i} {variable Offset$i; InsertLog "Offset$i = [set Offset$i]"}

   }
   
    proc Initialise {} {
      variable ID
    
      set ID ""
      for {set i 0} {$i <= 15} {incr i} {variable ID$i; set ID$i [ReadRegister ID$i];  append ID [format %c [set ID$i]] }
      
      if {[string compare -length 11 $ID "VMEIDXYC560"] == 0} {
#    passed
          WriteRegister Green 1
          WriteRegister Red 0
      } else {
#    failed
          WriteRegister Green 0
          WriteRegister Red 1
      }
     
   }

   proc do_Setting {reg vl} {InsertLog "Setting $reg $vl"

#      P1     Vector
#      P2     Mode
#      P3     Gain
#      P4     Channel
#      P5     Data

      variable $reg
      set $reg $vl

      switch $reg {
         IV  {WriteRegister Int.Vector [set $reg]}
         P2  {WriteRegister Mode [set $reg]}
         P3  {WriteRegister Gain [set $reg]}
         P4  {WriteRegister Channel [set $reg]}
         P5  {}
         default {InsertLog "do_Setting  unexpected request $reg"}
      }
   }

   proc do_Button {reg} {InsertLog "Button $reg"

#    P6  Red LED
#    P7  Green LED
#      P8     Interrupts
#      P9     Interrupts
      
      variable $reg
      set $reg [expr ([set $reg] +1) & 1]

      switch $reg {
         LR  {WriteRegister Red [set $reg]}
         LG  {WriteRegister Green [set $reg]}
         IP  {WriteRegister Int.Pending [set $reg]}
         IE  {WriteRegister Int.Enable [set $reg]}
         default {InsertLog "do_Button  unexpected request $reg"}
      }

   }
 
    proc UpdateModule {} {

 #       for {set i 0} {$i <= 7} {incr i} {variable Offset$i; set Offset$i [expr [ReadRegister Channel$i] & 4095]}

        variable P2; set P2 [expr [ReadRegister Mode] & 3]
        variable P3; set P3 [expr [ReadRegister Gain] & 3]
        variable P4; set P4 [expr [ReadRegister Channel] & 63]
        variable P5; set P5 [expr [ReadRegister Data] & 0x0fff]
        variable LR; set LR [expr [ReadRegister Red] & 1]
        variable LG; set LG [expr [ReadRegister Green] & 1]
        variable IP; set IP [expr [ReadRegister Int.Pending] & 1]
        variable IE; set IE [expr [ReadRegister Int.Enable] & 1]

   }

     proc do_Convert {} {WriteRegister Convert 1}

     proc do_HardwareReset {} {WriteRegister Reset 1; WriteRegister Reset 0}

    proc do_Save {which} {
        variable ModuleName
        variable ModuleIndex

           InsertLog "Saving Settings for [set ModuleName]#[set ModuleIndex]"
    }

    proc do_Restore {which} {
        variable ModuleName
        variable ModuleIndex

           InsertLog "Restoring Settings for [set ModuleName]#[set ModuleIndex]"
    }


     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set n [second [lindex $cgidata 1]]
              set vl [third [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   
                   SETTING  {do_Setting $n $vl}
                   
                   BUTTON   {do_Button $n}

                   HDWRE     {do_HardwareReset}
                   CONVERT   {do_Convert}

                   REDISPLAY  {UpdateModule} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

    UpdateModule
    Initialise

}   ;# end of if {$started == 0}

