

#    These procedures are used by all 

   variable LogFlag
   if {![info exists LogFlag]} {set LogFlag 0}

   variable ShowLogFlag
   if {![info exists ShowLogFlag]} {set ShowLogFlag 0}

   variable LogText
   if {![info exists LogText]} {set LogText ""}

   variable LogCount
   if {![info exists LogCount]} {set LogCount 0}

   variable FooterText
   if {![info exists FooterText]} {set FooterText ""}

   proc SetFooter {s} {
       variable FooterText
       set FooterText "[clock format [clock seconds] -format %H:%M:%S] - $s"
   }

   proc ClearFooter {} {
       variable FooterText
       set FooterText ""
   }


    proc InsertLog {s} {
        variable LogText
        variable LogCount
        variable LogFlag
        variable ShowLogFlag
        variable JS

        if {![info exists JS]} {puts "$s"; return} 

        if {$LogFlag == 1 && $ShowLogFlag == 1} {

            incr LogCount
            if {$LogCount == 1000} {EmptyLog}

            set LogText "$s\n[set LogText]"
        } else {
            if {$JS == ""} {append JS "alert(\""}
            append JS "[string map {\" \\" \n \\n} $s]\\n"
        }
        return ""
    }

    proc EmptyLog {} {
        variable LogText
        variable LogCount

        set LogText ""
        set LogCount 0
    }

    proc Inform {space command {params ""}} {
        global errorCode errorInfo
        set rc [catch {interp eval "" ::namespace inscope ::$space $command $params} m]
        if {$rc != 0} {
# puts "Inform => $errorCode $errorInfo"
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
           return $m
        }
    }

    proc Alert {s} {
        variable JS

        if {![info exists JS]} {puts "$s"; return} 

        if {$JS == ""} {append JS "alert(\""}
        append JS "[string map {\" \\" \n \\n} $s]\\n"
    }

    proc Confirm {t s} {
        variable JS

       if {$JS != ""} {append JS "\");"}
        append JS "if (confirm(\"[string map {\" \\" \n \\n} $s]\\n\\n\\nAre you sure you wish to continue?\")) \
            {click_CONFIRM(document.$t);}"

       append JS "(\""

    }

    proc Execute {args} {
        variable JS

       if {$JS != ""} {append JS "\");"}
        append JS "$args;"

       append JS "(\""

    }

    proc Information {s} {
        variable INFO

        set INFO ""
        append INFO "MyWindow=window.open(\"\",\"MyWindow\",\"toolbar=no,menubar=no,status=no,scrollbars=yes\");"
        append INFO "MyWindow.document.write(\"<html><body><tt>\");"
        append INFO "MyWindow.document.write(\"[string map {\" \\" \n <br>} $s]\\n\");"
        append INFO "MyWindow.document.write(\"</body></html>\");"
        append INFO "MyWindow.document.close();"
    }

    proc PrintLog {} {
        variable LogText

     if {[info procs ::DefineMessage] != "::DefineMessage"} {puts "DefineMessage unknown\n"; return}

        ::DefineMessage -c digitizer -l INFORMATION  "$LogText"
    }

    proc Elog {l s} {

     if {[info procs ::DefineMessage] != "::DefineMessage"} {puts "DefineMessage unknown\n"; return}

        ::DefineMessage -c digitizer -l $l  "$s"
    }

   proc do_help {} {
      variable HelpTopic 

        set Txtfile [file join $HelpTopic.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Sorry unable to access $Txtfile\nInformation coming very soon!!\n"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

