
#    MIDAS Httpd Service to provide NET Access


package require MIDASDomainHandler     ;#  load default support procedures

global MIDAS_NETAccessServer_Exists
set MIDAS_NETAccessServer_Exists 1

global MIDAS_NETAccessServer_Verbose
set MIDAS_NETAccessServer_Verbose 0

global MIDAS_SOAPDomainHandler_Verbose
set MIDAS_SOAPDomainHandler_Verbose 0


# Use namespaces to isolate your methods
namespace eval urn:NETAccessServer {

#    package require RegisterAccessServer       ;#  load common procedures

   global env
   source [file join $env(MIDASBASE) TclHttpd tcl RegisterAccessServer.tcl]
   if {$z != 0} {puts "RegisterAccessServer.tcl > $m"}

#    set up the Instrinsic registers

    set Address ""
    set Data 0
    set Status 0
    set Debug 0

    set RegisterIndex 1
 
    set RegisterBase $RegisterIndex

    set RegisterNames(HasBeenConfigured) $RegisterIndex
    set R[set RegisterIndex](class) netRegister
    incr RegisterIndex


#    netDigital register attributes

   set netDigital_options {
         {a.arg 0    "NET address"}
         {w.arg 32   "data width"}
         {p.arg "rw" "access permission"}
         {b.arg 0    "field width (bits)"}
         {l.arg 0    "field length (bits)"}
         {f.arg "x"  "data format returned"}
         {s.arg "0"  "return status"}
         {i.arg 0xa55a  "initial value"}
   }

   set netDigital_Updateoptions {
         {a.arg 0xa55a    "NET address"}
         {w.arg 0xa55a    "data width"}
         {p.arg 0xa55a    "access permission"}
         {b.arg 0xa55a    "field width (bits)"}
         {l.arg 0xa55a    "field length (bits)"}
         {f.arg 0xa55a    "data format returned"}
         {s.arg 0xa55a    "return status"}
         {i.arg 0xa55a    "initial value"}
    }

    set netDigital_Usage ": netDigital  -a ? -w 8|16|32 -p ro|wo|rw -b ? -l ? -f w|b|d -s 0|1 -i ?"


#    netAnalogue register attributes

   set netAnalogue_options {
         {a.arg 0    "NET address"}
         {w.arg 32   "data width"}
         {p.arg "rw" "access permission"}
         {q.arg ""   "prefix"}
         {u.arg ""   "unit"}
         {d.arg 4  "decimals"}
         {r.arg "0:0,0xffff:0xffff"      "range=min (hex):(real),max (hex):(real)"}
         {s.arg "0"  "return status"}
         {i.arg 0xa55a  "initial value"}
   }

   set netAnalogue_Updateoptions {
         {a.arg 0xa55a    "NET address"}
         {w.arg 0xa55a    "data width"}
         {p.arg 0xa55a    "access permission"}
         {q.arg 0xa55a   "prefix"}
         {u.arg 0xa55a   "unit"}
         {d.arg 0xa55a   "decimals"}
         {r.arg "0:0,0xffff:0xffff"      "range=min (hex):(real),max (hex):(real)"}
         {s.arg 0xa55a    "return status"}
         {i.arg 0xa55a    "initial value"}
    }

    set netAnalogue_Usage ": netAnalogue  -a ? -w 16|32 -p ro|wo|rw -s 0|1 -i ?"

    variable QUAL
    set QUAL {
        {a  1.0e-18}                                                ;#  /* ato   */
        {f  1.0e-15}                                                ;#   /* femto */
        {p  1.0e-12}                                                ;#  /* pico  */
        {n  1.0e-9 }                                               ;#   /* nano  */
        {u  1.0e-6 }                                                ;#  /* micro */
        {m  1.0e-3 }                                              ;#    /* milli */
        {c  0.01   }                                            ;#       /* centi */
        {d  0.1    }                                                ;#  /* deci  */
        {D  10.0   }                                              ;#    /* deca  */
        {h  100.0  }                                               ;#   /* hecto */
        {K  1.0e3  }                                                ;#   /* kilo  */
        {k  1.0e3  }                                                ;#   /* kilo  */
        {M  1.0e6  }                                                ;#   /* mega  */
        {G  1.0e9  }                                                 ;#  /* giga  */
        {T  1.0e12 }                                                ;#   /* tera  */
        {P  1.0e15 }                                             ;#     /* peta  */
        {E  1.0e18 }                                               ;#    /* exa   */
        {*  1.0  }}                                                ;#   /* default  */


    global NETData
    set NETData(0) 0

    proc scan-num s {    ;# remove after common.tcl updated
       if {[string first "0x" $s]==0} then {
         set z [scan [string range $s 2 end] %x zzz]
       } else {
         set z [scan $s %f zzz]
       }
       if {$z==1} then {return $zzz} else {return "???"}
    }

    proc stor str {      ;#   string str to real conversion     ie  1.2 mV => 0.0012
       variable QUAL

puts "stor: $str"
        scan $str "%f%n" value n
        set q [string range $str $n $n]    ;# extract the qualifier
        set vl $value
        foreach item $QUAL {
           if {[first $item] == $q} {set vl [expr $value * [second $item]]; break}
        }
puts "stor: $item value=$vl"
        return $vl
    }


    proc rtos {value q u} {          ;#  real value to string conversion   ie 0.0012 => 1.2mV
        variable QUAL

        foreach item $QUAL {
           if {[first $item] == $q} {set value [expr $value / [second $item]]}
        }
        if {$q == "*"} {
            set vl [format "%.3f%s" [expr 1.0 * $value] $u]
        } else {
            set vl [format "%.3f%s%s" [expr 1.0 * $value] $q $u]
        }
puts "rtos: value $q $u => $vl"
        return $vl
    }

    proc dtoa {value M C} {       ;#  digital to analogue conversion    y = (m * x) + c
puts "dtoa: $value $M $C"
       return [expr ($M * $value) + $C]
    }

    proc atod {value M C} {       ;#  analogue to digital conversion    x = (y - c) / m
puts "atod: $value $M $C"
      set vl [expr round(($value - $C) / $M)]
      return $vl
    }

    proc rdNET {Addr width} {
        global NETData
        global MIDAS_NETAccessServer_Verbose
        if {$MIDAS_NETAccessServer_Verbose} {puts "rdNET $Addr $width"}
        if {![info exists NETData($Addr)]} {set NETData($Addr) 0}
        switch $width {
            8   {set rc [expr [set NETData($Addr)] & 0xff]}
            16  {set rc [expr [set NETData($Addr)] & 0x0000ffff]}
            32 -
            default  {set rc [set NETData($Addr)]}
        }
        return [list 0 $rc]
    }

    proc wtNET {Addr width vl} {
        global NETData
        global MIDAS_NETAccessServer_Verbose
        if {$MIDAS_NETAccessServer_Verbose} {puts "wtNET $Addr $width $vl"}
        if {![info exists NETData($Addr)]} {set NETData($Addr) 0}
        switch $width {
            8   {set NETData($Addr) [expr $vl & 0xff]}
            16  {set NETData($Addr) [expr $vl & 0x0000ffff]}
            32 -
            default  {set NETData($Addr) $vl}
        }
        return [list 0 $vl]
    }

    proc AccessServerVerbose {option} {
        global MIDAS_NETAccessServer_Verbose
        global MIDAS_RegisterAccessServer_Verbose
        global MIDAS_SOAPDomainHandler_Verbose
        set MIDAS_NETAccessServer_Verbose $option
        set MIDAS_RegisterAccessServer_Verbose $option
        set MIDAS_SOAPDomainHandler_Verbose $option
        return [rpcvar::rpcvar int 0]
    }

    proc DefineRegister {Register Class Attributes} {
        global MIDAS_NETAccessServer_Verbose
        upvar RegisterIndex RegisterIndex
        upvar RegisterNames RegisterNames

        if {$MIDAS_NETAccessServer_Verbose} \
             {puts "called method NETAccessServer::DefineRegister with parameters $Register $Class $Attributes"}
             
#    Check Register name is not already in use

        if {[info exists RegisterNames($Register)]} then {
puts "$Register exists"
             return -code error -errorcode 0x20006 -errorinfo "Register name already in use"
        }

#    Check Class is valid

puts "checking class $Class"

        switch $Class {
            netDigital -
            netAnalogue  {}

            default {
               return -code error -errorcode 0x20007 -errorinfo "Class name is invalid or not supported"
            }
        }

#    create register

puts "creating $Register $Class"

        switch $Class {
            netDigital  {

                set RegisterNames($Register) $RegisterIndex

puts "RegisterNames $Register $RegisterIndex"

                upvar R$RegisterIndex R
                set R(class) $Class

                upvar netDigital_options options

                foreach item $options {
                    set opt [first [split [first $item] .]]
                    set R($opt) [second $item]
                }

                set R(LastRead)  0x0
                set R(LastWrite) 0x0

                incr RegisterIndex
            }
            netAnalogue  {

                set RegisterNames($Register) $RegisterIndex

puts "RegisterNames $Register $RegisterIndex"

                upvar R$RegisterIndex R
                set R(class) $Class

                upvar netAnalogue_options options

                foreach item $options {
                    set opt [first [split [first $item] .]]
                    set R($opt) [second $item]
                }

                set R(LastRead)  0x0
                set R(LastWrite) 0x0
                set R(Dmin) 0
                set R(Dmax) 0xffff
                set R(Amin) 0.0
                set R(Amax) 65535.0
                set R(M) 1.0
                set R(C) 0
                set R(prefix) " "
                set R(unit) ""

                incr RegisterIndex
            }
            default {
                return -code error -errorcode 0x20007 -errorinfo "Class name is invalid or not supported"
            }
        }

#    apply attributes

        return [do_WriteRegisterAttributes $Register $Attributes]
    }


    proc do_ReadRegisterAttributes {Register} {
        global MIDAS_NETAccessServer_Verbose

        upvar RegisterNames RegisterNames
       if {![info exists RegisterNames]} {upvar 2 RegisterNames RegisterNames}

        set Index $RegisterNames($Register)
        upvar 1 R$Index R
        if {![info exists R]} {upvar 2 R$Index R}

        switch $R(class) {
            netDigital {
                 set attributes "-a $R(a) -w $R(w) -p $R(p) -f $R(f) -s $R(s)"
                 if {$R(i) != 0xa55a} {append attributes " -i $R(i)"}
            }
            netAnalogue {
                 set attributes "-a $R(a) -w $R(w) -p $R(p) -q $R(q) -u $R(u) -d $R(d) -r $R(r) -s $R(s)"
                 if {$R(i) != 0xa55a} {append attributes " -i $R(i)"}
            }
            default {
                return -code error -errorcode 0x10004 -errorinfo "Invalid request"
            }
        }

        return $attributes
    }

    proc do_WriteRegisterAttributes {Register Attributes} {
        global MIDAS_NETAccessServer_Verbose
        variable QUAL

        upvar RegisterNames RegisterNames
       if {![info exists RegisterNames]} {upvar 2 RegisterNames RegisterNames}

        set Index $RegisterNames($Register)
        upvar 1 R$Index R
        if {![info exists R]} {upvar 2 R$Index R}

        switch $R(class) {
            netDigital  {

                upvar 2 netDigital_Updateoptions options
                upvar 2 netDigital_Usage usage

                array set params [::cmdline::getKnownOptions Attributes $options $usage]
                
                foreach m [array names params] {
                    set rc 0
                    switch $m {
                        a  {}
                        w  {if {$params(w) != 8 && $params(w) != 16 && $params(w) != 32} {set rc -1}}
                        p  {if {$params(p) != "rw" && $params(p) != "ro" && $params(p) != "wo"} {set rc -1}}
                        l  {if {$params(l) < 0 || $params(l) > 32} {set rc -1}}
                        b  {if {$params(b) < 0 || $params(b) > 32} {set rc -1}}
                        f  {if {$params(f) != "d" && $params(f) != "x" && $params(f) != "b"} {set rc -1}}
                        i  {}
                        s  {if {$params(s) != 0 && $params(s) != 1} {set rc -1}}
                        default {set rc -1}
                    }
                    if {$rc == 0 && $params($m) != 0xa55a} {set R($m) $params($m)}
                }
            }
            netAnalogue  {

                upvar 2 netAnalogue_Updateoptions options
                upvar 2 netAnalogue_Usage usage

                array set params [::cmdline::getKnownOptions Attributes $options $usage]
                
                foreach m [array names params] {
                    set rc 0
                    switch $m {
                        a  {}
                        w  {if {$params(w) != 16 && $params(w) != 32} {set rc -1}}
                        p  {if {$params(p) != "rw" && $params(p) != "ro" && $params(p) != "wo"} {set rc -1}}
                        q  {
                           foreach qual $QUAL {
                             if {$params(p) == [first $qual]} {set R(prefix) [second $qual]; break}
                           }
                           }
                        u  {}
                        d  {}
                        r  {
                           set Min [first [split $params(r) ,]]     ;# ie    0:0A
                           set Max [second [split $params(r) ,]]    ;# ie    0xfff:1.5mA
                           set R(Dmin) [first [split $Min :]]     ;# digital min    0
                           set R(Amin) [second [split $Min :]]    ;# analogue min  0A
                           set R(Dmax) [first [split $Max :]]     ;# digital max    0xfff
                           set R(Amax) [second [split $Max :]]    ;# analogue max  1.5mA

                           set field $R(Amin) 
                           scan $field "%f%n" value n                  ;#  0A 
                           set R(Umin) [string range $field $n end]    ;#   A

                           set field $R(Amax)
                           scan $field "%f%n" value n                ;#  1.5mA
                           set R(Umax) [string range $field $n end]  ;#  mA

                           if {$R(Dmin) > $R(Dmax)} {
                             set x $R(Amax)
                             set R(Amax) $R(Amin)
                             set R(Amin) $x
                             set x $R(Dmax)
                             set R(Dmax) $R(Dmin)
                             set R(Dmin) $x
                             set x $R(Umax)
                             set R(Umax $R(Umin)
                             set R(Umin) $x
                           }
                           set rMin [stor $R(Amin)]   ;#  0A => 0.0
                           set rMax [stor $R(Amax)]   ;#  1.5mA => 0.0015
                           set R(M) [expr ($rMax - $rMin) / ($R(Dmax) - $R(Dmin))]
                           set R(C) [expr $rMin - ($R(M) * $R(Dmin))]
        if {$MIDAS_NETAccessServer_Verbose} \
              {puts "WriteAttributes netAnalogue: $Min $Max $R(Dmin) $R(Dmax) $R(Amin) $R(Amax) $rMin $rMax $R(M) $R(C)"}
                           }
                        i  {}
                        s  {if {$params(s) != 0 && $params(s) != 1} {set rc -1}}
                        default {set rc -1}
                    }
                    if {$rc == 0 && $params($m) != 0xa55a} {set R($m) $params($m)}
                }
            }
            default {
                return -code error -errorcode 0x10004 -errorinfo "Invalid request"
            }
        }
 
        return 0
    }

    proc do_WriteRegister {Register Value} {

        global MIDAS_NETAccessServer_Verbose
        upvar RegisterNames RegisterNames
       if {![info exists RegisterNames]} {upvar 2 RegisterNames RegisterNames}

        if {$MIDAS_NETAccessServer_Verbose} \
             {puts "called method NETAccessServer::WriteRegister with parameters $Register $Value"}

        set Index $RegisterNames($Register)
        upvar 1 R$Index R
        if {![info exists R]} {upvar 2 R$Index R}

        switch $R(class) {
            netDigital  {
                if {$R(p) == "ro"} {
                    return -code error -errorcode 0x20004 -errorinfo "Register is not writeable"
                }

                if {($R(b) != 0) || ($R(l) != 0) } then {    ;#   need to get the current value

                    if {$MIDAS_NETAccessServer_Verbose} \
                        {puts "NET request a=$R(a) w=$R(w)"}

                    set Addr $R(a)
                    set DataWidth $R(w)

                    set rc [rdNET $Addr $DataWidth]

                    if {$MIDAS_NETAccessServer_Verbose}  {puts "NET reply $rc"}

                    if {[first $rc] != 0} {return -code error -errorcode $rc -errorinfo "NET access error"}
                    set data [second $rc]

#    data now contains data last written or data read back
#    it is raw - not masked or shifted
#    mask only those bits not to be changed by this write
#    then mask out those bits to be changed by this write
#    and OR in this write data

                    set data [expr $data  & ~(~(~0 << $R(l)) << $R(b))]
                    set vl [expr (($Value & ~(~0 << $R(l))) << $R(b)) | $data]

                } else {set vl $Value}

                if {$MIDAS_NETAccessServer_Verbose} \
                    {puts "NET request a=$R(a) w=$R(w) data=$vl"}

                set Addr $R(a)
                set DataWidth $R(w)

                set rc [wtNET $Addr $DataWidth $vl]

                if {$MIDAS_NETAccessServer_Verbose}  {puts "NET reply $rc"}

                if {[first $rc] < 0} {return -code error -errorcode $rc -errorinfo "NET access error"}

                set R(LastWrite) $Value
            }
            netAnalogue  {
                if {$R(p) == "ro"} {
                    return -code error -errorcode 0x20004 -errorinfo "Register is not writeable"
                }

                set Addr $R(a)
                set DataWidth $R(w)

                set vl [atod [stor $Value] $R(M) $R(C)]  ;# convert from analogue to digital

                if {$MIDAS_NETAccessServer_Verbose} {puts "NET request a=$R(a) w=$R(w) data=$Value"}
                if {$MIDAS_NETAccessServer_Verbose} {puts "Write: $R(C) $R(M) $vl"}

                set rc [wtNET $Addr $DataWidth $vl]

                if {[first $rc] < 0} {return -code error -errorcode $rc -errorinfo "NET access error"}

                set R(LastWrite) $Value
            }
            default {
                return -code error -errorcode 0x10004 -errorinfo "Invalid request"
            }
        }
 
        return 0
    }

    proc do_ReadRegister {Register} {

        global MIDAS_NETAccessServer_Verbose
        upvar 1 RegisterNames RegisterNames
        if {![info exists RegisterNames]} {upvar 2 RegisterNames RegisterNames}

        if {$MIDAS_NETAccessServer_Verbose} \
             {puts "called method NETAccessServer::ReadRegister with parameters $Register"}

        set Index $RegisterNames($Register)
        upvar 1 R$Index R
        if {![info exists R]} {upvar 2 R$Index R}

        switch $R(class) {
            netDigital  {
                if {$R(p) == "wo"} then {
                    set Value $R(LastWrite)
                } else {
                    if {$MIDAS_NETAccessServer_Verbose} \
                        {puts "NET request a=$R(a) w=$R(w)"}

                    set Addr $R(a)
                    set DataWidth $R(w)

                    set rc [rdNET $Addr $DataWidth]

                    if {$MIDAS_NETAccessServer_Verbose}  {puts "NET reply $rc"}

                    if {[first $rc] < 0} {return -code error -errorcode $rc -errorinfo "NET access error"}

                    set Value [second $rc]; set R(LastRead) $Value

                    if {($R(b) != 0) || ($R(l) != 0)} then {set Value [expr ($Value >> $R(b)) & ~(~0 << $R(l))]}

                    switch $R(f) {
                        x   {set Value [format "0x%0*x" [expr $R(w)/4] $Value]}
                        d   {set Value [format "%d" $Value]}
                        b   {}
                    }
                }
            }
           netAnalogue  {
                if {$R(p) == "wo"} then {
                    set Value $R(LastWrite)
                } else {
                    if {$MIDAS_NETAccessServer_Verbose} \
                        {puts "NET request a=$R(a) w=$R(w)"}

                    set Addr $R(a)
                    set DataWidth $R(w)

                    set rc [rdNET $Addr $DataWidth]

                    if {$MIDAS_NETAccessServer_Verbose}  {puts "NET reply $rc"}

                    if {[first $rc] < 0} {return -code error -errorcode $rc -errorinfo "NET access error"}

                    set Value [second $rc]; set R(LastRead) $Value
                 }

                 if {$Value > $R(Dmax)} {set Value $R(Dmax)}
                 if {$Value < $R(Dmin)} {set Value $R(Dmin)}

                 set vl [rtos [dtoa $Value $R(M) $R(C)] $R(q) $R(u)]
    if {$MIDAS_NETAccessServer_Verbose}  {puts "Read: $vl $Value $R(Amax) $R(Amin)  $R(Dmax) $R(Dmin) $R(M) $R(C) $R(q) $R(u)"}
                 set Value $vl
            }
            default {
                return -code error -errorcode 0x10004 -errorinfo "Invalid request"
            }
        }
        return $Value
    }


    # We have to publish the public methods...

     SOAP::export AccessServerVerbose
     SOAP::export DefineRegister
     SOAP::export InquireRegisters
     SOAP::export ReadRegisterAttributes
     SOAP::export ReadRegistersAttributes
     SOAP::export DeleteRegister
     SOAP::export DeleteRegisters
     SOAP::export WriteRegisterAttributes
     SOAP::export WriteRegistersAttributes
     SOAP::export WriteRegister
     SOAP::export WriteRegisters
     SOAP::export InitialiseRegister
     SOAP::export InitialiseRegisters
     SOAP::export ReadRegister
     SOAP::export ReadRegisters

}

# register this service with tclhttpd
puts [SOAP::Domain::register  -prefix  /NETAccessServer  -namespace urn:NETAccessServer -uri urn:NETAccessServer]


proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/NETAccessServer {optsname sock args} {   \
    ::SOAP::Domain::MIDAS_SOAPDomainHandler_/DefaultAccessServer $optsname $sock $args}



package provide NETAccessServer 1.0
